# PyHarry100

A CLI tool designed to help beginners efficiently learn Python through the 100 Days of Code challenge by [CodeWithHarry](https://www.codewithharry.com/). It provides structured learning with:

- **Notes**: Concise explanations of key concepts.  
- **Extra In-Depth Notes**: Additional insights to deepen your understanding.  
- **Tasks**: Exercises to reinforce learning.  
- **Extra Tasks**: Additional challenges to enhance problem-solving skills.  
- **Where to Go After**: Suggested content for further exploration beyond each day's video.  

## Features

- **Download Daily Learning Material**  
  Run the following command to download content for a specific day:

  ```sh
  pyharry100 day1
  ```
  This will download:

  - **Tasks**
  - **Extra Tasks**
  - **Notes**
  - **Harry’s Notes**
  - **“Where to Go After” recommendations**
  
(Currently available for Day 1 to Day 5, full 100-day content coming soon!)

- **Check Learning Status**  
    To check your progress for a particular day:
    ```sh
    pyharry100 status
    ```
    This will display:
    - **Day Completion status**
    - **Total Points**
    - **Points Accomplished**

- **Test your task**  
    To test your task for a particular day:
    ```sh
    pyharry100 test
    ```

## Installation
To intall pyharry100, run:
```sh
pip install pyharry100
```

## Usage
After installation, you can start using the CLI tool by running:
```sh
pyharry100 <command>
```

### Future Updates

- **Extend content to all 100 days**
- **More advanced tasks and challenges**
- **Interactive learning features**


## Contributing

Contributions are welcome! If you'd like to improve this tool, feel free to fork the repository and submit a pull request.  

You can contribute to the repository of this Python package here:  
[GitHub Repository: Zain-Zameer/pyharry100](https://github.com/Zain-Zameer/pyharry100)
